const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const pharmacies = sequelize.define(
    'pharmacies',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

pharmacy_name: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

address: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  pharmacies.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity















    db.pharmacies.hasMany(db.medications, {
      as: 'medications_pharmacy',
      foreignKey: {
          name: 'pharmacyId',
      },
      constraints: false,
    });




































































































//end loop



    db.pharmacies.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.pharmacies.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.pharmacies.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return pharmacies;
};


